"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../../node_modules/.pnpm/parse-numeric-range@1.3.0/node_modules/parse-numeric-range/index.js
var require_parse_numeric_range = __commonJS({
  "../../../node_modules/.pnpm/parse-numeric-range@1.3.0/node_modules/parse-numeric-range/index.js"(exports, module2) {
    function parsePart(string) {
      let res = [];
      let m;
      for (let str of string.split(",").map((str2) => str2.trim())) {
        if (/^-?\d+$/.test(str)) {
          res.push(parseInt(str, 10));
        } else if (m = str.match(/^(-?\d+)(-|\.\.\.?|\u2025|\u2026|\u22EF)(-?\d+)$/)) {
          let [_, lhs, sep, rhs] = m;
          if (lhs && rhs) {
            lhs = parseInt(lhs);
            rhs = parseInt(rhs);
            const incr = lhs < rhs ? 1 : -1;
            if (sep === "-" || sep === ".." || sep === "\u2025")
              rhs += incr;
            for (let i = lhs; i !== rhs; i += incr)
              res.push(i);
          }
        }
      }
      return res;
    }
    exports.default = parsePart;
    module2.exports = parsePart;
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  pluginTextMarkers: () => pluginTextMarkers,
  pluginTextMarkersData: () => pluginTextMarkersData
});
module.exports = __toCommonJS(src_exports);
var import_core4 = require("@expressive-code/core");
var import_parse_numeric_range = __toESM(require_parse_numeric_range(), 1);
var import_unist_util_visit_parents = require("unist-util-visit-parents");

// src/marker-types.ts
var MarkerTypeOrder = ["mark", "del", "ins"];
function markerTypeFromString(input) {
  if (input === "add")
    input = "ins";
  if (input === "rem")
    input = "del";
  const markerType = input;
  return MarkerTypeOrder.includes(markerType) ? markerType : void 0;
}

// src/styles.ts
var import_core = require("@expressive-code/core");
var textMarkersStyleSettings = new import_core.StyleSettings({
  lineMarkerAccentMargin: "0rem",
  lineMarkerAccentWidth: "0.15rem",
  lineDiffIndicatorMarginLeft: "0.5rem",
  inlineMarkerBorderWidth: "1.5px",
  inlineMarkerBorderRadius: "0.2rem",
  inlineMarkerPadding: "0.15rem",
  // Define base colors for all markers in the LCH color space,
  // which leads to consistent perceived brightness independent of hue
  markHue: "284",
  insHue: "136",
  delHue: "33",
  defaultChroma: "40",
  defaultLuminance: ["32%", "75%"],
  backgroundOpacity: "50%",
  borderLuminance: "48%",
  borderOpacity: "81.6%",
  indicatorLuminance: ["67%", "40%"],
  indicatorOpacity: "81.6%",
  // You can use these to override the diff indicator content
  insDiffIndicatorContent: "'+'",
  delDiffIndicatorContent: "'-'",
  // The settings below will be calculated by setDefaults()
  markBackground: "",
  markBorderColor: "",
  insBackground: "",
  insBorderColor: "",
  insDiffIndicatorColor: "",
  delBackground: "",
  delBorderColor: "",
  delDiffIndicatorColor: ""
});
setDefaults("markHue", "markBackground", "markBorderColor");
setDefaults("insHue", "insBackground", "insBorderColor", "insDiffIndicatorColor");
setDefaults("delHue", "delBackground", "delBorderColor", "delDiffIndicatorColor");
function getTextMarkersBaseStyles(theme, coreStyles, styleOverrides) {
  const styles = textMarkersStyleSettings.resolve({
    theme,
    coreStyles,
    styleOverrides
  });
  const result = `
		.${import_core.codeLineClass} {
			/* Support line-level mark/ins/del */
			&.mark {
				--line-marker-bg-color: ${styles.markBackground};
				--line-marker-border-color: ${styles.markBorderColor};
			}
			&.ins {
				--line-marker-bg-color: ${styles.insBackground};
				--line-marker-border-color: ${styles.insBorderColor};
				&::before {
					content: ${styles.insDiffIndicatorContent};
					color: ${styles.insDiffIndicatorColor};
				}
			}
			&.del {
				--line-marker-bg-color: ${styles.delBackground};
				--line-marker-border-color: ${styles.delBorderColor};
				&::before {
					content: ${styles.delDiffIndicatorContent};
					color: ${styles.delDiffIndicatorColor};
				}
			}
			&.mark,
			&.ins,
			&.del {
				--accent-margin: ${styles.lineMarkerAccentMargin};
				--accent-width: ${styles.lineMarkerAccentWidth};
				position: relative;
				background: var(--line-marker-bg-color);
				margin-inline-start: var(--accent-margin);
				border-inline-start: var(--accent-width) solid var(--line-marker-border-color);
				padding-inline-start: calc(${coreStyles.codePaddingInline} - var(--accent-margin) - var(--accent-width)) !important;
				&::before {
					position: absolute;
					left: ${styles.lineDiffIndicatorMarginLeft};
				}
			}

			/* Support inline mark/ins/del */
			& mark {
				--inline-marker-bg-color: ${styles.markBackground};
				--inline-marker-border-color: ${styles.markBorderColor};
			}
			& ins {
				--inline-marker-bg-color: ${styles.insBackground};
				--inline-marker-border-color: ${styles.insBorderColor};
			}
			& del {
				--inline-marker-bg-color: ${styles.delBackground};
				--inline-marker-border-color: ${styles.delBorderColor};
			}
			& mark,
			& ins,
			& del {
				all: unset;
				display: inline-block;
				position: relative;
				--border: ${styles.inlineMarkerBorderWidth};
				--border-l: var(--border);
				--border-r: var(--border);
				--radius-l: ${styles.inlineMarkerBorderRadius};
				--radius-r: ${styles.inlineMarkerBorderRadius};
				margin-inline: 0.025rem;
				padding-inline: ${styles.inlineMarkerPadding};
				border-radius: var(--radius-l) var(--radius-r) var(--radius-r) var(--radius-l);
				background: var(--inline-marker-bg-color);
				background-clip: padding-box;

				&.open-start {
					margin-inline-start: 0;
					padding-inline-start: 0;
					--border-l: 0px;
					--radius-l: 0;
				}
				&.open-end {
					margin-inline-end: 0;
					padding-inline-end: 0;
					--border-r: 0px;
					--radius-r: 0;
				}
				&::before {
					content: '';
					display: inline-block;
					position: absolute;
					inset: 0;
					border-radius: var(--radius-l) var(--radius-r) var(--radius-r) var(--radius-l);
					border: var(--border) solid var(--inline-marker-border-color);
					border-inline-width: var(--border-l) var(--border-r);
				}
			}
		}
	`;
  return result;
}
function getMarkerTypeColorsForContrastCalculation({
  theme,
  coreStyles,
  styleOverrides
}) {
  const textMarkersStyles = textMarkersStyleSettings.resolve({
    theme,
    coreStyles,
    styleOverrides
  });
  const defaultTextMarkersStyles = textMarkersStyleSettings.resolve({
    theme,
    coreStyles
  });
  const colorOrDefault = (input, defaultColor) => input[0] === "#" ? input : defaultColor;
  const result = {
    mark: colorOrDefault(textMarkersStyles.markBackground, defaultTextMarkersStyles.markBackground),
    ins: colorOrDefault(textMarkersStyles.insBackground, defaultTextMarkersStyles.insBackground),
    del: colorOrDefault(textMarkersStyles.delBackground, defaultTextMarkersStyles.delBackground)
  };
  return result;
}
function setDefaults(hue, bg, border, indicator) {
  const lch = (l, c, h2, a) => (0, import_core.toHexColor)(`lch(${l} ${c} ${h2} / ${a})`);
  textMarkersStyleSettings.defaultSettings[bg] = ({ resolveSetting: r }) => lch(r("defaultLuminance"), r("defaultChroma"), r(hue), r("backgroundOpacity"));
  textMarkersStyleSettings.defaultSettings[border] = ({ resolveSetting: r }) => lch(r("borderLuminance"), r("defaultChroma"), r(hue), r("borderOpacity"));
  if (indicator)
    textMarkersStyleSettings.defaultSettings[indicator] = ({ resolveSetting: r }) => lch(r("indicatorLuminance"), r("defaultChroma"), r(hue), r("indicatorOpacity"));
}

// src/inline-markers.ts
var import_core2 = require("@expressive-code/core");
function getInlineSearchTermMatches(lineText, blockData) {
  const markerMatches = [];
  blockData.plaintextTerms.forEach(({ markerType, text }) => {
    let idx = lineText.indexOf(text, 0);
    while (idx > -1) {
      markerMatches.push({
        markerType,
        start: idx,
        end: idx + text.length
      });
      idx = lineText.indexOf(text, idx + text.length);
    }
  });
  blockData.regExpTerms.forEach(({ markerType, regExp }) => {
    const matches = lineText.matchAll(regExp);
    for (const match of matches) {
      const rawGroupIndices = (0, import_core2.getGroupIndicesFromRegExpMatch)(match);
      let groupIndices = rawGroupIndices.flatMap((range) => range ? [range] : []);
      if (!groupIndices.length) {
        const fullMatchIndex = match.index;
        groupIndices = [[fullMatchIndex, fullMatchIndex + match[0].length]];
      }
      if (groupIndices.length > 1) {
        groupIndices.shift();
      }
      groupIndices.forEach((range) => {
        markerMatches.push({
          markerType,
          start: range[0],
          end: range[1]
        });
      });
    }
  });
  return markerMatches;
}
function flattenInlineMarkerRanges(markerRanges) {
  const flattenedRanges = [];
  const sortedRanges = [...markerRanges].sort((a, b) => a.start - b.start);
  const posInRange = (pos) => {
    for (let idx = 0; idx < flattenedRanges.length; idx++) {
      const range = flattenedRanges[idx];
      if (pos < range.end)
        return {
          idx,
          range: pos >= range.start ? range : void 0
        };
    }
    return {
      idx: flattenedRanges.length
    };
  };
  MarkerTypeOrder.forEach((markerType) => {
    sortedRanges.filter((range) => range.markerType === markerType).forEach((rangeToAdd) => {
      rangeToAdd = { ...rangeToAdd };
      const posStart = posInRange(rangeToAdd.start);
      const posEnd = posInRange(rangeToAdd.end);
      const newElements = [rangeToAdd];
      if (posStart.range && rangeToAdd.start !== posStart.range.start) {
        if (posStart.range.markerType === rangeToAdd.markerType) {
          rangeToAdd.start = posStart.range.start;
        } else {
          newElements.unshift({
            ...posStart.range,
            end: rangeToAdd.start
          });
        }
      }
      if (posEnd.range && rangeToAdd.end !== posEnd.range.end) {
        if (posEnd.range.markerType === rangeToAdd.markerType) {
          rangeToAdd.end = posEnd.range.end;
        } else {
          newElements.push({
            ...posEnd.range,
            start: rangeToAdd.end
          });
        }
      }
      flattenedRanges.splice(posStart.idx, posEnd.idx - posStart.idx + 1, ...newElements);
    });
  });
  return flattenedRanges;
}

// src/annotations.ts
var import_core3 = require("@expressive-code/core");
var import_hastscript = require("hastscript");
var TextMarkerAnnotation = class extends import_core3.ExpressiveCodeAnnotation {
  markerType;
  backgroundColor;
  constructor({ markerType, backgroundColor, ...baseOptions }) {
    super(baseOptions);
    this.markerType = markerType;
    this.backgroundColor = backgroundColor;
  }
  render(options) {
    if (!this.inlineRange)
      return this.renderFullLineMarker(options);
    return this.renderInlineMarker(options);
  }
  renderFullLineMarker({ nodesToTransform }) {
    return nodesToTransform.map((node) => {
      node.data = node.data || {};
      node.data.textMarkersBackgroundColor = this.backgroundColor;
      (0, import_core3.addClass)(node, this.markerType);
      return node;
    });
  }
  renderInlineMarker({ nodesToTransform }) {
    return nodesToTransform.map((node, idx) => {
      const transformedNode = (0, import_hastscript.h)(this.markerType, node);
      transformedNode.data = transformedNode.data || {};
      transformedNode.data.textMarkersBackgroundColor = this.backgroundColor;
      if (nodesToTransform.length > 0 && idx > 0) {
        (0, import_core3.addClass)(transformedNode, "open-start");
      }
      if (nodesToTransform.length > 0 && idx < nodesToTransform.length - 1) {
        (0, import_core3.addClass)(transformedNode, "open-end");
      }
      return transformedNode;
    });
  }
};

// src/index.ts
function pluginTextMarkers(options = {}) {
  return {
    name: "TextMarkers",
    baseStyles: ({ theme, coreStyles }) => getTextMarkersBaseStyles(theme, coreStyles, options.styleOverrides || {}),
    hooks: {
      preprocessMetadata: ({ codeBlock, theme, coreStyles }) => {
        const markerTypeColors = getMarkerTypeColorsForContrastCalculation({
          theme,
          coreStyles,
          styleOverrides: options.styleOverrides
        });
        const blockData = pluginTextMarkersData.getOrCreateFor(codeBlock);
        codeBlock.meta = (0, import_core4.replaceDelimitedValues)(
          codeBlock.meta,
          ({ fullMatch, key, value, valueStartDelimiter }) => {
            const markerType = markerTypeFromString(key || "mark");
            if (!markerType)
              return fullMatch;
            if (valueStartDelimiter === "{") {
              const lineNumbers = (0, import_parse_numeric_range.default)(value);
              lineNumbers.forEach((lineNumber) => {
                const lineIndex = lineNumber - 1;
                codeBlock.getLine(lineIndex)?.addAnnotation(
                  new TextMarkerAnnotation({
                    markerType,
                    backgroundColor: markerTypeColors[markerType]
                  })
                );
              });
              return "";
            }
            if (valueStartDelimiter === "/") {
              let regExp;
              try {
                regExp = new RegExp(value, "gd");
              } catch (error) {
                regExp = new RegExp(value, "g");
              }
              blockData.regExpTerms.push({
                markerType,
                regExp
              });
              return "";
            }
            blockData.plaintextTerms.push({
              markerType,
              text: value
            });
            return "";
          },
          {
            valueDelimiters: ['"', "'", "/", "{...}"],
            keyValueSeparator: "="
          }
        );
      },
      annotateCode: ({ codeBlock, theme, coreStyles }) => {
        const markerTypeColors = getMarkerTypeColorsForContrastCalculation({
          theme,
          coreStyles,
          styleOverrides: options.styleOverrides
        });
        const blockData = pluginTextMarkersData.getOrCreateFor(codeBlock);
        codeBlock.getLines().forEach((line) => {
          const markerRanges = getInlineSearchTermMatches(line.text, blockData);
          if (!markerRanges.length)
            return;
          const flattenedRanges = flattenInlineMarkerRanges(markerRanges);
          flattenedRanges.forEach(({ markerType, start, end }) => {
            line.addAnnotation(
              new TextMarkerAnnotation({
                markerType,
                backgroundColor: markerTypeColors[markerType],
                inlineRange: {
                  columnStart: start,
                  columnEnd: end
                }
              })
            );
          });
        });
      },
      postprocessRenderedLine: ({ renderData, theme, coreStyles }) => {
        const backgroundColor = coreStyles.codeBackground[0] === "#" ? coreStyles.codeBackground : theme.bg;
        (0, import_unist_util_visit_parents.visitParents)(renderData.lineAst, (node, ancestors) => {
          if (node.type !== "element" || !node.properties || !node.data)
            return;
          const textColor = typeof node.data.inlineStyleColor === "string" ? node.data.inlineStyleColor : void 0;
          if (!textColor)
            return;
          let combinedBackgroundColor = backgroundColor;
          ancestors.forEach((ancestor) => {
            const markerBackgroundColor = typeof ancestor.data?.textMarkersBackgroundColor === "string" ? ancestor.data.textMarkersBackgroundColor : void 0;
            if (!markerBackgroundColor)
              return;
            combinedBackgroundColor = (0, import_core4.onBackground)(markerBackgroundColor, combinedBackgroundColor);
          });
          if (combinedBackgroundColor === backgroundColor)
            return;
          const readableTextColor = (0, import_core4.ensureColorContrastOnBackground)(textColor, combinedBackgroundColor);
          if (readableTextColor.toLowerCase() === textColor.toLowerCase())
            return;
          node.data.inlineStyleColor = readableTextColor;
          node.properties.style = `color:${readableTextColor}${node.properties.style?.toString().replace(/^(color:[^;]+)(;|$)/, "$2") || ""}`;
        });
      }
    }
  };
}
var pluginTextMarkersData = new import_core4.AttachedPluginData(() => ({ plaintextTerms: [], regExpTerms: [] }));
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginTextMarkers,
  pluginTextMarkersData
});
//# sourceMappingURL=index.cjs.map