import { StyleSettings, ExpressiveCodePlugin, AttachedPluginData } from '@expressive-code/core';

type MarkerType = 'mark' | 'ins' | 'del';

declare const textMarkersStyleSettings: StyleSettings<"lineMarkerAccentMargin" | "lineMarkerAccentWidth" | "lineDiffIndicatorMarginLeft" | "inlineMarkerBorderWidth" | "inlineMarkerBorderRadius" | "inlineMarkerPadding" | "markHue" | "insHue" | "delHue" | "defaultChroma" | "defaultLuminance" | "backgroundOpacity" | "borderLuminance" | "borderOpacity" | "indicatorLuminance" | "indicatorOpacity" | "insDiffIndicatorContent" | "delDiffIndicatorContent" | "markBackground" | "markBorderColor" | "insBackground" | "insBorderColor" | "insDiffIndicatorColor" | "delBackground" | "delBorderColor" | "delDiffIndicatorColor">;

interface PluginTextMarkersOptions {
    styleOverrides?: Partial<typeof textMarkersStyleSettings.defaultSettings>;
}
declare function pluginTextMarkers(options?: PluginTextMarkersOptions): ExpressiveCodePlugin;
interface PluginTextMarkersData {
    plaintextTerms: {
        markerType: MarkerType;
        text: string;
    }[];
    regExpTerms: {
        markerType: MarkerType;
        regExp: RegExp;
    }[];
}
declare const pluginTextMarkersData: AttachedPluginData<PluginTextMarkersData>;

export { PluginTextMarkersData, PluginTextMarkersOptions, pluginTextMarkers, pluginTextMarkersData };
